// Definicije metoda uz klasu Crtez.

#include "crtez.h"
using namespace std;

namespace Figure {
  void Crtez::kopiraj(const Crtez& crt) {       // Kopiranje u crtez.
    A = crt.A; s = crt.s; v = crt.v;
    for (auto pf: figure) pf->kopija();
  }

  void Crtez::premesti(Crtez& crt) {            // Premestanje u crtez.
    A = crt.A; s = crt.s; v = crt.v;
    figure = crt.figure;
  }

  void Crtez::brisi() {                         // Oslobadjanje memorije.
    for (auto pf: figure) delete pf;
    figure.clear();
  }

  Boja Crtez::boja(const Tacka& T) const {      // Boja tacke.
    if (!pripada(T)) throw G_tacka_ne_pripada();
    Tacka T1(T.uzmi_x()-A.uzmi_x(), T.uzmi_y()-A.uzmi_y());
    for (auto i=figure.rbegin(); i!=figure.rend(); i++)
      try { return (*i)->boja(T1); } catch (G_tacka_ne_pripada) {}
    return Figura::boja();
  }

  void Crtez::pisi(ostream& it) const {        // Pisanje.
    static string marg = "";
    it << " A=" << A << " s=" << s << " v=" << v;
    marg += "   ";
    for (auto pf: figure) it << endl << marg << *pf;
    marg.erase(0,3);
  }
} // namespace Figure

