// Definicija apstraktne klase za iteratore (Iter).

#ifndef _iter_h_
#define _iter_h_

#include "figura1.h"

class Iter {
public:
  virtual ~Iter() {}                            // Virtuelni destruktor.
  virtual bool ima() const =0;                  // Ima li tekuceg elementa?
  virtual Iter& poc() =0;                       // Pomeranje na pocetak.
  virtual Iter&  operator++() =0;               // Pomeranje korak napred.
  virtual Figura* operator->() =0;              // Pokazivac na figuru.
  Figura& operator*()                           // Vrednost figure.
    { return *operator->(); }
  virtual Iter& operator+=(Figura* fig) =0;     // Umetanje figure.
  Iter& operator+=(const Figura& fig)
    { return *this += fig.kopija(); }
  virtual Iter& operator-=(Figura*& fig) =0;    // Vaenje figure.
  Figura* operator~()                           // Vaenje figure.
    { Figura* fig; *this -= fig; return fig; }

  // Varijante ranijih operacija za nepromenljive zbirke.
  friend const Iter& poc(const Iter& i)         // Pomeranje na pocetak.
    { return const_cast<Iter&>(i).poc(); }
  friend const Iter& operator++(const Iter& i)  // Pomeranje korak napred.
    { return ++const_cast<Iter&>(i); }
  const Figura* operator->() const              // Pokazivac na figuru.
    { return const_cast<Iter&>(*this).operator->(); }
  const Figura& operator*() const               // Vrednost figure.
    { return *operator->(); }
};

#endif
